module ELPO where

import Term
import Linear
import qualified EKBO

--  import Parser

type Parameter = (Linear.Algebra, EKBO.Precedence)

showParameter :: Parameter -> String
showParameter (a, p) =
  "ELPO with interpretations on natural numbers\n\n" ++
  showAlgebra a ++
  "\nand precedence:\n\n" ++
  EKBO.showPrecedence p ++ "\n"

-- LPO-based SPO

gtLPO :: Parameter -> Term -> Term -> Bool
gtLPO param s t = gtLPO12 param s t || gtLPO3 param s t

gtLPO12 :: Parameter -> Term -> Term -> Bool
gtLPO12 param@(a, p) s@(F _ ss) t@(F _ ts) =
  (EKBO.gtB a p s t ||
   (EKBO.geqB a s t && EKBO.gtLex (gtLPO param) ss ts)) &&
  all (gtLPO param s) ts
gtLPO12 _ _ _  = False
  
gtLPO3 :: Parameter -> Term -> Term -> Bool
gtLPO3 param (F _ ss) t = any (\s -> geqLPO param s t) ss
gtLPO3 _ _ _            = False

geqLPO :: Parameter -> Term -> Term -> Bool
geqLPO param s t = s == t || gtLPO param s t

-- LPO-based MSPO

gt :: Parameter -> Term -> Term -> Bool
gt param@(a, _) s t = geqA a s t && gtLPO param s t
