module LPO where

import Data.List
import Term

type Precedence = [String]

-- Pretty printers

showParameter :: Precedence -> String
showParameter p =
  "LPO with precedence:\n\n" ++
  "  " ++ intercalate " > " p ++ "\n"

-- LPO

gtLex :: Eq a => (a -> a -> Bool) -> [a] -> [a] -> Bool
gtLex _ [] []              = False
gtLex rel (x : xs) (y : ys) = rel x y || (x == y && gtLex rel xs ys)
gtLex _ _ _ = error "gtLex"

gtPrec :: Precedence -> String -> String -> Bool
gtPrec [] _ _ = False
gtPrec (f : fs) g h
  | f == g    = elem h fs
  | otherwise = gtPrec fs g h 

gtLPO :: Precedence -> Term -> Term -> Bool
gtLPO prec s t = gtLPO12 prec s t || gtLPO3 prec s t

gtLPO12 :: Precedence -> Term -> Term -> Bool
gtLPO12 prec s@(F f ss) (F g ts) =
  (gtPrec prec f g ||
   (f == g && gtLex (gtLPO prec) ss ts)) &&
  all (gtLPO prec s) ts
gtLPO12 _ _ _  = False
  
gtLPO3 :: Precedence -> Term -> Term -> Bool
gtLPO3 param (F _ ss) t = any (\s -> geqLPO param s t) ss
gtLPO3 _ _ _            = False

geqLPO :: Precedence -> Term -> Term -> Bool
geqLPO param s t = s == t || gtLPO param s t
